## libaunit 3.7.1

=== Makefile ===
RTS =
TARGET =
GPRBUILD  = gprbuild
GPRCLEAN = gprclean

INSTALL:=$(shell exec=`which gprbuild`;if [ ! -x "$$exec" ]; then unset exec;fi;echo $$exec | sed -e 's/\/bin\/$(GPRBUILD).*//')

ifeq ($(RTS),)
   RTS=full
   RTS_CONF =
else
   RTS_CONF = --RTS=$(RTS)
endif

ifeq ($(TARGET),)
   TARGET=native
   TARGET_CONF =
else
   TARGET_CONF = --target=$(TARGET)
endif

MODE = Install

CONF_ARGS = $(TARGET_CONF) $(RTS_CONF)

# Install directories

I_INC   = $(INSTALL)/include/aunit
I_LIB   = $(INSTALL)/lib/aunit
I_GPR   = $(INSTALL)/lib/gnat
I_TPL   = $(INSTALL)/share/examples/aunit
I_DOC   = $(INSTALL)/share/doc/aunit
I_PLG   = $(INSTALL)/share/gps/plug-ins

.PHONY: all clean targets install_clean install

all:
	$(GPRBUILD) -Plib/gnat/aunit_build -p -XMODE=$(MODE) -XRUNTIME=$(RTS) -XPLATFORM=$(TARGET) $(CONF_ARGS)

clean:
	$(RM) -fr lib/aunit lib/aunit-obj
	-${MAKE} -C docs clean

install_clean:
ifeq ($(INSTALL),)
	@echo 'Error when installing: $$INSTALL is empty...'
	@echo "Please set an installation path before installing !"
else
	$(RM) -rf $(I_DOC)
	$(RM) -rf $(I_TPL)
	$(RM) -f $(I_PLG)/aunit.xml
	$(RM) -rf $(I_LIB)
	$(RM) -rf $(I_INC)
	$(RM) -f $(I_GPR)/aunit_build.gpr
	$(RM) -f $(I_GPR)/aunit.gpr
	$(RM) -f $(I_GPR)/aunit_shared.gpr
endif

install: install_clean
ifneq ($(INSTALL),)
	$(MKDIR) $(I_DOC)
	$(MKDIR) $(I_TPL)
	$(MKDIR) $(I_PLG)
	$(MKDIR) $(I_GPR)
	$(MKDIR) $(I_LIB)
	$(MKDIR) $(I_INC)
	@for doc in docs/*.html docs/*.info docs/*.pdf docs/*.txt ; do \
	   if [ -f $$doc ]; then \
	      echo $(CP) $$doc $(I_DOC) ; \
	      $(CP) $$doc $(I_DOC) ; \
           fi \
        done
	-$(CP) support/aunit.xml $(I_PLG)

	-$(CPR) lib/gnat lib/aunit $(INSTALL)/lib
	-$(CPR) include/aunit $(INSTALL)/include
	-$(CPR) share/examples $(INSTALL)/share
	@echo '------------------------------------------------------------------'
	@echo '--  AUnit has now been installed.'
	@echo '--  To be able to use the library, you may need to update your'
	@echo '--  ADA_PROJECT_PATH or GPR_PROJECT_PATH to point to the path'
	@echo '--  $(I_GPR)'
	@echo '------------------------------------------------------------------'
endif

doc:
	${MAKE} -C docs

RMDIR	= rmdir
MKDIR	= mkdir -p
RM	= rm
CP	= cp
CPR	= cp -r
CHMOD	= chmod

=== test/Makefile ===
GPRBUILD  = gprbuild
GPRCLEAN  = gprclean

.PHONY: all test force

all: test

RTS =
TARGET =

ifeq ($(RTS),)
   RTS = full
   RTS_CONF =
else
   RTS_CONF = --RTS=$(RTS)
endif

ifeq ($(TARGET),)
   TARGET = native
   TARGET_CONF =
else
   TARGET_CONF = --target=$(TARGET)
endif

CONF_ARGS = $(TARGET_CONF) $(RTS_CONF)

ifeq ($(OS),Windows_NT)
 ifeq ($(TARGET),native)
   exeext=.exe
 endif
endif

ifeq ($(findstring vxworks,$(TARGET)),vxworks)
   exeext=.out
endif

RUN=
ifeq ($(TARGET),powerpc-elf)
   RUN=./support/run-ppc-elf
endif

VARIANT=
ifeq ($(TARGET),powerpc-elf)
   VARIANT=-XVARIANT=powerpc-elf-psim
endif
ifeq ($(TARGET),lmp-elf)
   VARIANT=-XVARIANT=lmp-elf
endif

ifneq ($(findstring aunit.gpr,$(wildcard ../lib/gnat/*.gpr)),)
   PROJECT_PATH_ARG = GPR_PROJECT_PATH=../lib/gnat
endif

build: $(SUPPORTLIB) aunit_tests.gpr
	$(PROJECT_PATH_ARG) $(GPRBUILD) -p -Paunit_tests $(CONF_ARGS) -XRUNTIME=$(RTS) -XPLATFORM=$(TARGET) $(VARIANT) $(LARGS)

run: build
	-$(RUN) ./exe/$(TARGET)-$(RTS)/aunit_harness$(exeext)

test: build
	-$(RUN) ./exe/$(TARGET)-$(RTS)/aunit_harness$(exeext) > test.out.full 2>&1
	egrep "^Total|^Success|^Fail|^Unexp" test.out.full > test.out
	diff -b test.out expected.out
	@echo
	@echo "[OK] AUNIT TEST IS SUCCESSFUL"

aunit_tests.gpr: aunit_tests.gpr.in force
	rm -f $@
	touch $@
ifneq ($(strip $(filter-out full pthread xenomail kernel default, $(RTS))),)
ifeq ($(NO_ZFP_SUPPORT),)
	echo "with \"zfp_support\";" >> $@
endif
endif
	@cat $< >> $@

clean:
	$(RM) -rf obj exe support/obj support/lib *.cgpr test.out

RMDIR	= rmdir
MKDIR	= mkdir -p
RM	= rm
CP	= cp -p

=== share/examples/aunit/test_fixture/Makefile ===
all:
	gprbuild -p -Pharness
clean:
	-gprclean -Pharness
	-gprclean -Ptested_lib/testlib
	rm -rf obj tested_lib/obj

## libaunit 1.03

=== debian/changelog ===
libaunit (1.03-8) unstable; urgency=low

  * Adopting the package. Closes: #673752.
  * Switch to debhelper 9, dpkg-dev and dh-ada-library helpers.
  * Build-Depends: gnat in addition to gnat-4.6 to ensure default compiler.
  * Standards-Version: 3.9.5. Vcs-*: correct field names.
  * Stop depending on inexistant ada-compiler virtual package.
  * Mark lib and -dev packages as Multiarch: same.
  * copyright: update, machine-readable format 1.0.
  * Move runtime tests to debian/tests. XS-Testsuite field accordingly.
  * rules: inherit hardening flags. Do not compress examples. Implement clean.
  * source.lintian overrides: -lib does Depend on -dbg.
  * Empty but informative watch file.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 30 Nov 2013 22:30:03 +0100

libaunit (1.03-7) unstable; urgency=low

  * upgrade to build with gnat-4.6; bump aliversion

 -- Stephen Leake <stephen_leake@stephe-leake.org>  Tue, 12 Jul 2011 18:34:15 -0400

libaunit (1.03-6) unstable; urgency=low

  * debian/compat: bump to 7

  * debian/control: add gnat, ada-compiler per Debian Ada Policy.

  * debian/source/format: switch to 3.0 (quilt)

  * debian/rules: don't install GPS plug-in aunit.xml; it's wrong.

 -- Stephen Leake <stephen_leake@stephe-leake.org>  Tue, 15 Jun 2010 03:31:31 -0400

libaunit (1.03-5) unstable; urgency=low

  [Stephen Leake]
  * debian/control (Standards-Version): update to 3.8.4
    (Architecture): change to 'any', to match gnat-4.4. Closes: #568438

  [Ludovic Brenta]
  * debian/control (DM-Upload-Allowed): new.   (Uploaders): remove myself.

 -- Stephen Leake <stephen_leake@stephe-leake.org>  Sun, 14 Feb 2010 08:23:32 -0500

libaunit (1.03-4) unstable; urgency=low

  [Stephen Leake]
  * Change -dev package name to reflect the change in .ali files (see
    extensive discussion at
    http://people.debian.org/~lbrenta/debian-ada-policy.html):
    - libaunit-dev -> libaunit1-dev
  * NEW package libaunit-dbg
  * Migrate to gnat-4.4 and change the soname to libaunit3.
  * Update Standards-Version to 3.8.3 with no changes.
  * debian/control (Architecture): add kfreebsd-amd64.  Closes: #542414.
    (Vcs-Mtn, Vcs-Browse): new.
    (Maintainer): new maintainer Stephen Leake.
    (Uploaders): add Ludovic Brenta as the sponsor.
    (Suggests): new
    (Conflicts, Replaces): new
  * debian/test_installed.sh: New, for running tests against installed
    package.

  [Ludovic Brenta]
  * debian/control (Depends): add ${misc:Depends}, required by debhelper.
    (Architectures): disable alpha due to http://gcc.gnu.org/PR42073.
  * debian/aunit_ref.gpr: s/Object_Dir/Library_ALI_Dir/.
  * debian/aunit_build.gpr: build without -fstack-check.
    Eric Botcazou says: "-fstack-check is broken with GCC 4.4 on x86/x86-64
    Linux, it generates code that will easily segfault"
    (http://gcc.gnu.org/PR20548).

 -- Ludovic Brenta <lbrenta@debian.org>  Thu, 19 Nov 2009 23:46:01 +0100

libaunit (1.03-3) unstable; urgency=low

  * Migrate to gnat-4.3 and change the soname to libaunit2.
  * Update Standards-Version to 3.8.0 with no changes.
  * Add support for mips, mipsel and ppc64.
  * Transform aunit.gpr into a library project file.

 -- Ludovic Brenta <lbrenta@debian.org>  Thu, 24 Jul 2008 20:56:02 +0200

libaunit (1.03-2) unstable; urgency=low

  * debian/control (Maintainer): use my Debian email address.

 -- Ludovic Brenta <lbrenta@debian.org>  Mon, 18 Sep 2006 23:09:04 +0200

libaunit (1.03-1) unstable; urgency=low

  * New upstream release.
  * Compile with GCC 4.1; new ABI.
  * debian/control (Maintainer): new email address, I'm now a full DD.
    (Upoloaders): remove.
    (Build-Depends): gnat (>= 4.1).
    (Standards-Version): bump to 3.7.2 with no changes required.
    (libaunit1): rename to libaunit1.03.
    (Architecture): add alpha, amd64, hppa, ia64 and s390.
  * debian/rules: bump the soname to libaunit.so.1.03.

 -- Ludovic Brenta <lbrenta@debian.org>  Mon, 18 Sep 2006 00:15:11 +0200

libaunit (1.01-3) unstable; urgency=low

  * debian/rules (regexp): accept any character in the Debian upload
    number.  Closes: #359880.

 -- Ludovic Brenta <ludovic@ludovic-brenta.org>  Fri, 31 Mar 2006 08:08:36 +0200

libaunit (1.01-2) unstable; urgency=low

  * debian/control: enable support for GNU/kFreeBSD.  Update
    standards-version from 3.6.1 to 3.6.2 with no changes.  Change
    maintainer's email address.  Add Alexander Wirt to the list of
    uploaders.
    (libaunit-dev): Depend on gnat, suggest gnat-gps.
  * debian/libaunit-dev.postinst: remove, no longer needed.

 -- Ludovic Brenta <ludovic@ludovic-brenta.org>  Wed,  1 Mar 2006 20:23:20 +0100

libaunit (1.01-1) unstable; urgency=low

  * Initial Release.

 -- Ludovic Brenta <ludovic.brenta@insalien.org>  Tue, 24 Feb 2004 02:33:37 +0100

Local variables:
left-margin: 2
End:

=== debian/control ===
Source: libaunit
Section: libdevel
Priority: extra
Maintainer: Nicolas Boulenguez <nicolas@debian.org>
Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 9),
 gnat, gnat-4.6,
 dh-ada-library
Standards-Version: 3.9.5
Homepage: http://libre.adacore.com/libre/
Vcs-Mtn: www.ada-france.org org.debian.libaunit
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libaunit
XS-Testsuite: autopkgtest

Package: libaunit2-dev
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Conflicts: libaunit-dev, libaunit1-dev
Replaces: libaunit-dev, libaunit1-dev
Description: AUnit, a unit testing framework for Ada: development
 AUnit is a set of Ada packages based on the xUnit family of unit test
 frameworks. It's intended as a developer's tool to facilitate
 confident writing and evolution of Ada software. It is purposely
 lightweight, as one of its main goals is to make it easy to develop
 and run unit tests, rather than to generate artifacts for process
 management. The framework supports easy composition of sets of unit
 tests to provide flexibility in determining what tests to run for a
 given purpose.
 .
 Install this package if you want to write programs that use AUnit.

Package: libaunit-dbg
Section: debug
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${ada:Depends}
Recommends: ${ada:Recommends}
Suggests: ${ada:Suggests}
Description: AUnit, a unit testing framework for Ada: debug symbols
 AUnit is a set of Ada packages based on the xUnit family of unit test
 frameworks. It's intended as a developer's tool to facilitate
 confident writing and evolution of Ada software. It is purposely
 lightweight, as one of its main goals is to make it easy to develop
 and run unit tests, rather than to generate artifacts for process
 management. The framework supports easy composition of sets of unit
 tests to provide flexibility in determining what tests to run for a
 given purpose.
 .
 This package contains the runtime debug symbols.

Package: libaunit3
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: AUnit, a unit testing framework for Ada: shared library
 AUnit is a set of Ada packages based on the xUnit family of unit test
 frameworks. It's intended as a developer's tool to facilitate
 confident writing and evolution of Ada software. It is purposely
 lightweight, as one of its main goals is to make it easy to develop
 and run unit tests, rather than to generate artifacts for process
 management. The framework supports easy composition of sets of unit
 tests to provide flexibility in determining what tests to run for a
 given purpose.
 .
 This package contains the runtime shared library.

=== debian/rules ===
#!/usr/bin/make -f
#
# Debian Makefile for AUnit
# Copyright (c) 2009      Stephen Leake <stephen_leake@stephe-leake.org>
# Copyright (c) 2004-2006 Ludovic Brenta <ludovic@ludovic-brenta.org>
# Copyright (c) 2013      Nicolas Boulenguez <nicolas@debian.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#
include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging.mk

ADAFLAGS += -gnatfno -gnatwa -gnatVa

LIB_NAME := $(patsubst lib%,%,$(DEB_SOURCE))

SOVERSION := $(shell sed -n -e "s/^Package: lib$(LIB_NAME)\([[:digit:]]\+\)$$/\1/p" debian/control)
ifndef SOVERSION
  $(warning Could not guess SOVERSION from debian/control)
  # Not error. Policy defines targets that may be run from outside build dir.
endif

######################################################################
POLICY_TARGETS := binary binary-arch binary-indep build build-arch \
  build-indep clean
.PHONY: $(POLICY_TARGETS)
$(POLICY_TARGETS):
	dh $@ --with ada-library

PROJECT := debian/$(LIB_NAME).gpr
override_dh_auto_build-arch:
	gnatmake $(BUILDER_OPTIONS) -P$(PROJECT) -XKIND=static \
          $(foreach var,ADAFLAGS,-X$(var)="$($(var))")
	gnatmake $(BUILDER_OPTIONS) -P$(PROJECT) -XKIND=dynamic \
          $(foreach var,ADAFLAGS LDFLAGS SOVERSION,-X$(var)="$($(var))")

override_dh_auto_clean:
	rm -f $(foreach k, dynamic static \
             ,$(foreach d, lib obj \
             ,debian/$(LIB_NAME)-$(d)-$(k)/*))

# First package is -dev, but we avoid depending on the aliversion.
override_dh_compress:
	dh_compress --exclude=-dev/examples/
	dh_compress --remaining-packages

######################################################################
RUN_TESTS_TMP := lib$(LIB_NAME)-run-tests-XXXXXXXXXX

# The plural is a lie: only link-with-shared is executed.
# You may run the other test with a manual modification.
# TODO: use adttest and remove all this.

run-tests:
	ADTTMP=`mktemp --tmpdir --directory $(RUN_TESTS_TMP)` && \
        ADTTMP=$$ADTTMP sh debian/tests/link-with-shared 2> $$ADTTMP/stderr; \
        status=$$?; cat $$ADTTMP/stderr; \
        if test $$status != 0; then \
          echo "Test failed: non zero exit status ($$status)."; \
        elif test -s $$ADTTMP/stderr; then \
          echo "Test failed: activity on stderr."; \
        fi; \
        rm -f -r $$ADTTMP

=== debian/tests/control ===
Tests: link-with-shared upstream-tests

=== debian/watch ===
# Upstream does not provide any webpage with a tarball list. The
# copyright file contains an URL than can be checked manually.

## libaunit 3.7.1

=== debian/changelog ===
libaunit (3.7.1-2) unstable; urgency=medium

  * For reproducible PDF timestamps, set clock to the date of this entry.
    Touch generated sources for deterministic ALI files and tar headers.
  * Standards-Version: 3.9.6 (no changes).

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 03 May 2015 16:49:18 +0200

libaunit (3.7.1-1) unstable; urgency=medium

  * New upstream release, built with gnat-4.9 (closes:  #748998, #755078).
    Per Ada policy, rename lib (ABI) and -dev (sources) packages.
  * Because the generated doc is big, use Files-Excluded.
    Because it and examples are -indep, add a -doc package.
  * copyright: update to GPL-3+, repackage without generated files.
  * rules: run-tests target is obsoleted by sadt from devscripts.
    Now using upstream build system with a few patches.
  * doc-base registration. Install all formats and examples.
  * examples: deduplicate, link from doc, run as tests.
    Some of them and upstream-tests freeze, commented.
  * Fix dh_compress override.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 18 Aug 2014 16:39:25 +0200

=== debian/control ===
--- 
+++ 
@@ -3,19 +3,25 @@
 Priority: extra
 Maintainer: Nicolas Boulenguez <nicolas@debian.org>
 Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 9),
- gnat, gnat-4.6,
+ gnat, gnat-4.9,
  dh-ada-library
-Standards-Version: 3.9.5
+Build-Depends-Indep:
+# To deduplicate examples in rules.
+ rdfind, symlinks,
+# Called in rules for deterministic PDF timestamps.
+ faketime,
+ texinfo, texlive-latex-base
+Standards-Version: 3.9.6
 Homepage: http://libre.adacore.com/libre/
 Vcs-Mtn: www.ada-france.org org.debian.libaunit
 Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libaunit
 XS-Testsuite: autopkgtest
 
-Package: libaunit2-dev
+Package: libaunit3.7.1-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
-Conflicts: libaunit-dev, libaunit1-dev
-Replaces: libaunit-dev, libaunit1-dev
+Recommends: libaunit-doc (= ${source:Version})
+Suggests: libaunit-dbg (= ${source:Version})
 Description: AUnit, a unit testing framework for Ada: development
  AUnit is a set of Ada packages based on the xUnit family of unit test
  frameworks. It's intended as a developer's tool to facilitate
@@ -47,7 +53,7 @@
  .
  This package contains the runtime debug symbols.
 
-Package: libaunit3
+Package: libaunit3.7.1
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -64,3 +70,20 @@
  given purpose.
  .
  This package contains the runtime shared library.
+
+Package: libaunit-doc
+Section: doc
+Architecture: all
+Depends: ${misc:Depends}
+Suggests: gnat
+Description: AUnit, a unit testing framework for Ada: documentation
+ AUnit is a set of Ada packages based on the xUnit family of unit test
+ frameworks. It's intended as a developer's tool to facilitate
+ confident writing and evolution of Ada software. It is purposely
+ lightweight, as one of its main goals is to make it easy to develop
+ and run unit tests, rather than to generate artifacts for process
+ management. The framework supports easy composition of sets of unit
+ tests to provide flexibility in determining what tests to run for a
+ given purpose.
+ .
+ This package contains documentation.

=== debian/rules ===
#!/usr/bin/make -f
#
# Debian Makefile for AUnit
# Copyright (c) 2009      Stephen Leake <stephen_leake@stephe-leake.org>
# Copyright (c) 2004-2006 Ludovic Brenta <ludovic@ludovic-brenta.org>
# Copyright (c) 2013-2015 Nicolas Boulenguez <nicolas@debian.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#
include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging.mk

DEB_DATE_RFC_2822 := $(shell dpkg-parsechangelog -S date)
DEB_DATE_RFC_3339 := $(shell date "+%F %T" -d "$(DEB_DATE_RFC_2822)")

ADAFLAGS += -gnatfno -gnatwa -gnatVa

LIB_NAME := $(patsubst lib%,%,$(DEB_SOURCE))

SOVERSION := $(shell sed debian/control -ne \
  '/^Package: $(DEB_SOURCE)\([0-9.]\+\)$$/ { s//\1/; p; q}')
ifndef SOVERSION
  $(warning Could not guess SOVERSION from debian/control)
  # Not error. Policy defines targets that may be run from outside build dir.
endif

######################################################################
POLICY_TARGETS := binary binary-arch binary-indep build build-arch \
  build-indep clean
.PHONY: $(POLICY_TARGETS)
$(POLICY_TARGETS):
	dh $@ --with ada-library

# Ignore upstream Makefile/configure.
.PHONY: $(addprefix override_dh_auto_,configure build-arch build-indep test install clean)

PROJECT := lib/gnat/aunit_build.gpr
override_dh_auto_build-arch:
 # Touch generated sources for deterministic ALI files and tar headers.
	find . -depth -newermt '$(DEB_DATE_RFC_3339)' -print0 | \
	  xargs -0r touch --no-dereference --date='$(DEB_DATE_RFC_3339)'
	$(MAKE) INSTALL=false \
	  GPRBUILD='gnatmake $(BUILDER_OPTIONS) -XLIBRARY_KIND=static $(foreach var,ADAFLAGS,"-X$(var)=$($(var))")'
	$(MAKE) INSTALL=false \
	  GPRBUILD='gnatmake $(BUILDER_OPTIONS) -XLIBRARY_KIND=dynamic $(foreach var,ADAFLAGS LDFLAGS SOVERSION,"-X$(var)=$($(var))")'

override_dh_auto_build-indep: version_information.backup
 # Freeze the clock for deterministic PDF timestamps.
	faketime -f "$(DEB_DATE_RFC_3339)" \
	$(MAKE) -C docs
version_information.backup: %.backup: %
	mv $* $@
	echo MAJOR_VERSION=$(DEB_VERSION_UPSTREAM) \
	  | sed 's/\./.\nMINOR_VERSION=/' > $*

# Currently fails.
# override_dh_auto_test:
# 	$(MAKE) -C test 'GPRBUILD=gnatmake $(BUILDER_OPTIONS) $(foreach var,ADAFLAGS LDFLAGS,"-X$(var)=$($(var))")'

override_dh_auto_clean::
	dh_auto_clean
	if test -e version_information.backup; then \
	  mv version_information.backup version_information; \
	fi
	$(MAKE) -C test GPRCLEAN=gnatclean clean

# The order in this list matters for rdfind.
EXAMPLES := simple_test test_caller test_fixture calculator failures liskov
INSTALLED_EXAMPLES := $(addprefix debian/libaunit-doc/usr/share/doc/libaunit-doc/examples/,$(EXAMPLES))
.PHONY: override_dh_installexamples-indep
override_dh_installexamples-indep:
	dh_installexamples --indep
  # Gnatmake will always be available, not gprbuild.
  # -eS allows testing these examples in run-time tests.
	sed -i 's/gprbuild/gnatmake -eS/;s/gprclean/gnatclean/' $(addsuffix /Makefile,$(INSTALLED_EXAMPLES))
  # Replace duplicate files with symlinks.
	rdfind -outputname /dev/null -makesymlinks true $(INSTALLED_EXAMPLES)
  # symlinks to make them relative (only if -indep build).
	symlinks -r -s -c $(INSTALLED_EXAMPLES)

.PHONY: override_dh_compress
override_dh_compress:
	dh_compress --package=libaunit-doc --exclude=usr/share/doc/libaunit-doc/examples/
# Check calculator/tests/stack-test.adb.gz
	dh_compress --remaining-packages

=== debian/tests/control ===
Tests: link-with-shared examples
# upstream-tests

## libaunit 3.7.2

=== Makefile ===
RTS =
TARGET =
GPRBUILD  = gprbuild
GPRCLEAN = gprclean
GPRINSTALL = gprinstall

INSTALL:=$(shell exec=`which gprbuild`;if [ ! -x "$$exec" ]; then unset exec;fi;echo $$exec | sed -e 's/\/bin\/$(GPRBUILD).*//')

ifeq ($(RTS),)
   RTS=full
   RTS_CONF =
else
   RTS_CONF = --RTS=$(RTS)
endif

ifeq ($(TARGET),)
   TARGET=native
   TARGET_CONF =
else
   TARGET_CONF = --target=$(TARGET)
endif

MODE = Install

CONF_ARGS = $(TARGET_CONF) $(RTS_CONF)

GPROPTS = $(CONF_ARGS) -XMODE=$(MODE) -XRUNTIME=$(RTS) -XPLATFORM=$(TARGET)

.PHONY: all clean targets install_clean install

all:
	$(GPRBUILD) -p $(GPROPTS) lib/gnat/aunit.gpr

clean-lib:
	$(RM) -fr lib/aunit lib/aunit-obj

clean: clean-lib
	-${MAKE} -C docs clean

install-clean:
ifneq (,$(wildcard $(INSTALL)/lib/gnat/manifests/aunit))
	-$(GPRINSTALL) $(GPROPTS) --uninstall --prefix=$(INSTALL) \
		--project-subdir=lib/gnat aunit
endif

install: install-clean
	$(GPRINSTALL) $(GPROPTS) -p -f --prefix=$(INSTALL) \
		--no-build-var --project-subdir=lib/gnat lib/gnat/aunit.gpr

doc:
	${MAKE} -C docs

RM	= rm

=== test/Makefile ===
GPRBUILD  = gprbuild
GPRCLEAN  = gprclean

.PHONY: all test force

all: test

RTS =
TARGET =

ifeq ($(RTS),)
   RTS = full
   RTS_CONF =
else
   RTS_CONF = --RTS=$(RTS)
endif

ifeq ($(TARGET),)
   TARGET = native
   TARGET_CONF =
else
   TARGET_CONF = --target=$(TARGET)
endif

CONF_ARGS = $(TARGET_CONF) $(RTS_CONF)

ifeq ($(OS),Windows_NT)
 ifeq ($(TARGET),native)
   exeext=.exe
 endif
endif

ifeq ($(findstring vxworks,$(TARGET)),vxworks)
   exeext=.out
endif

RUN=
ifeq ($(TARGET),powerpc-elf)
   RUN=./support/run-ppc-elf
endif

ifneq ($(findstring aunit.gpr,$(wildcard ../lib/gnat/*.gpr)),)
   PROJECT_PATH_ARG = GPR_PROJECT_PATH=../lib/gnat
endif

build:
	$(PROJECT_PATH_ARG) $(GPRBUILD) -p -Paunit_tests $(CONF_ARGS) $(LARGS)

run: build
	-$(RUN) ./exe/$(TARGET)-$(RTS)/aunit_harness$(exeext)

test: build
	-$(RUN) ./exe/aunit_harness$(exeext) > test.out.full 2>&1
	egrep "^Total|^Success|^Fail|^Unexp" test.out.full > test.out
	diff -b test.out expected.out
	@echo
	@echo "[OK] AUNIT TEST IS SUCCESSFUL"

clean:
	$(RM) -rf obj exe support/obj support/lib *.cgpr test.out

RMDIR	= rmdir
MKDIR	= mkdir -p
RM	= rm
CP	= cp -p

=== debian/changelog ===
libaunit (3.7.2-1) unstable; urgency=medium

  * New upstream release (GPL-2015, betwwen 3.7.1 and 3.8.0).
    Rename lib (SO=3.7.2) and -dev (ALI=3.7.2) packages due to Ada policy.
    Build with gnat-6, gprbuild and all hardening options.
  * watch, README.source: use Adacore redirector.
  * Switch from manual -dbg packages to automatic -dbgsym packages.
  * Standards-Version: 3.9.8 (no changes), drop generated XS-Testsuite.
  * rules: avoid timezone dependency when possible.
  * patches/path_doc_gps_plugin.diff: typo in package name.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 26 Apr 2016 08:32:42 +0200

=== debian/control ===
--- 
+++ 
@@ -3,25 +3,26 @@
 Priority: extra
 Maintainer: Nicolas Boulenguez <nicolas@debian.org>
 Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 9),
- gnat, gnat-4.9,
- dh-ada-library
+ gnat, gnat-6,
+# gprbuild compatible with gnat-6
+ gprbuild (>= 2015-2),
+# dh-ada-library knowing that -dbg packages are obsolete.
+ dh-ada-library (>= 6.7)
 Build-Depends-Indep:
 # To deduplicate examples in rules.
  rdfind, symlinks,
 # Called in rules for deterministic PDF timestamps.
  faketime,
  texinfo, texlive-latex-base
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: http://libre.adacore.com/libre/
 Vcs-Mtn: www.ada-france.org org.debian.libaunit
 Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libaunit
-XS-Testsuite: autopkgtest
 
-Package: libaunit3.7.1-dev
+Package: libaunit3.7.2-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
 Recommends: libaunit-doc (= ${source:Version})
-Suggests: libaunit-dbg (= ${source:Version})
 Description: AUnit, a unit testing framework for Ada: development
  AUnit is a set of Ada packages based on the xUnit family of unit test
  frameworks. It's intended as a developer's tool to facilitate
@@ -34,26 +35,7 @@
  .
  Install this package if you want to write programs that use AUnit.
 
-Package: libaunit-dbg
-Section: debug
-Architecture: any
-Multi-Arch: same
-Depends: ${misc:Depends}, ${ada:Depends}
-Recommends: ${ada:Recommends}
-Suggests: ${ada:Suggests}
-Description: AUnit, a unit testing framework for Ada: debug symbols
- AUnit is a set of Ada packages based on the xUnit family of unit test
- frameworks. It's intended as a developer's tool to facilitate
- confident writing and evolution of Ada software. It is purposely
- lightweight, as one of its main goals is to make it easy to develop
- and run unit tests, rather than to generate artifacts for process
- management. The framework supports easy composition of sets of unit
- tests to provide flexibility in determining what tests to run for a
- given purpose.
- .
- This package contains the runtime debug symbols.
-
-Package: libaunit3.7.1
+Package: libaunit3.7.2
 Section: libs
 Architecture: any
 Multi-Arch: same

=== debian/rules ===
#!/usr/bin/make -f
#
# Debian Makefile for AUnit
# Copyright (c) 2009      Stephen Leake <stephen_leake@stephe-leake.org>
# Copyright (c) 2004-2006 Ludovic Brenta <ludovic@ludovic-brenta.org>
# Copyright (c) 2013-2016 Nicolas Boulenguez <nicolas@debian.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
# PIE should only affect the static library.
include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging*.mk

DEB_DATE := $(shell dpkg-parsechangelog -S date)

ADAFLAGS += -gnatfno -gnatwa -gnatVa

LIB_NAME := $(patsubst lib%,%,$(DEB_SOURCE))

SOVERSION := $(shell sed debian/control -ne \
  '/^Package: $(DEB_SOURCE)\([0-9.]\+\)$$/ { s//\1/; p; q}')
ifndef SOVERSION
  $(warning Could not guess SOVERSION from debian/control)
  # Not error. Policy defines targets that may be run from outside build dir.
endif

######################################################################
POLICY_TARGETS := binary binary-arch binary-indep build build-arch \
  build-indep clean
.PHONY: $(POLICY_TARGETS)
$(POLICY_TARGETS):
	dh $@ --with ada-library

######################################################################
# Ignore upstream Makefile/configure.
.PHONY: $(addprefix override_dh_auto_,configure build-arch build-indep test install clean)

override_dh_auto_build-arch:
	$(MAKE) \
	  GPRBUILD='gprbuild $(BUILDER_OPTIONS) -XLIBRARY_KIND=static "-XADAFLAGS=$(ADAFLAGS) -fPIE" "-XSOVERSION=$(SOVERSION)"'

	$(MAKE) \
	  GPRBUILD='gprbuild $(BUILDER_OPTIONS) -XLIBRARY_KIND=dynamic $(foreach var,ADAFLAGS LDFLAGS SOVERSION,"-X$(var)=$($(var))")'

TOUCHED_TOO_MUCH := \
 include/aunit/containers/ada_containers-aunit_lists.adb
override_dh_auto_build-arch: deterministic-timestamps-in-ali-files-stamp
deterministic-timestamps-in-ali-files-stamp:
	touch --date='$(DEB_DATE)' $(TOUCHED_TOO_MUCH)
	touch $@

# For the freeze option, the faketime API does not allow to explicit
# the time zone, introducing an implicit dependency on it.
DEB_DATE_FAKETIME := $(shell date "+%F %T" -d "$(DEB_DATE)")
override_dh_auto_build-indep: version_information.backup
 # Freeze the clock for deterministic PDF timestamps.
	faketime -f "$(DEB_DATE_FAKETIME)" \
	$(MAKE) -C docs
version_information.backup: %.backup: %
	mv $* $@
	echo MAJOR_VERSION=$(DEB_VERSION_UPSTREAM) \
	  | sed 's/\./.\nMINOR_VERSION=/' > $*

override_dh_auto_clean::
	dh_auto_clean
	if test -e version_information.backup; then \
	  mv version_information.backup version_information; \
	fi

######################################################################
# The order in this list matters for rdfind.
EXAMPLES := simple_test test_caller test_fixture calculator failures liskov
INSTALLED_EXAMPLES := $(addprefix debian/libaunit-doc/usr/share/doc/libaunit-doc/examples/,$(EXAMPLES))
.PHONY: override_dh_installexamples-indep
override_dh_installexamples-indep:
	dh_installexamples --indep
  # Replace duplicate files with symlinks.
	rdfind -outputname /dev/null -makesymlinks true $(INSTALLED_EXAMPLES)
  # symlinks to make them relative (only if -indep build).
	symlinks -r -s -c $(INSTALLED_EXAMPLES)

######################################################################
.PHONY: override_dh_compress
override_dh_compress:
	dh_compress --package=libaunit-doc --exclude=usr/share/doc/libaunit-doc/examples/
# Check calculator/tests/stack-test.adb.gz
	dh_compress --remaining-packages

=== debian/watch ===
version=3
opts=filenamemangle=s/^.*download=//,dversionmangle=s/^.*\.// \
https://qa.debian.org/cgi-bin/fakeupstream.cgi?upstream=adacore/aws \
.*aws-gpl-(\d{4})-src\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

# Major and minor versions must be set manually (see README.source),
# but at least trigger an alarm for new releases.

## libaunit 17.2017

=== Makefile ===
--- 
+++ 
@@ -47,7 +47,8 @@
 	$(GPRINSTALL) $(GPROPTS) -p -f --prefix=$(INSTALL) \
 		--no-build-var --project-subdir=lib/gnat lib/gnat/aunit.gpr
 
+.PHONY: doc
 doc:
-	${MAKE} -C docs
+	${MAKE} -C doc
 
 RM	= rm

=== debian/changelog ===
libaunit (17.2017-2) unstable; urgency=medium

  * Upload to unstable. Rename packages with new shared object version
    (runtime) and .ali version (-dev) as described in Ada policy.
  * Drop explicit rules targets confusing dh.
  * Drop Recommends: removed -doc package.
  * Standards-Version: 4.0.1. Priority: optional.

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 09 Aug 2017 16:54:05 +0200

libaunit (17.2017-1) experimental; urgency=medium

  * New upstream release built with gnat-7. No ALI/SO bump in experimental.
    Drop -doc package, documentation is under GFDL with Front-Cover Texts.
  * Debhelper 10.
  * Standards-Version 4.0.0. HTTPS copyright format URL.
  * watch: fix package name, use version 4 syntax.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 06 Jul 2017 16:46:20 +0200

=== debian/control ===
Source: libaunit
Section: libdevel
Priority: optional
Maintainer: Nicolas Boulenguez <nicolas@debian.org>
Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 10),
 gnat, gnat-7,
# This line is parsed by debian/rules.
# gprbuild compatible with gnat-6
 gprbuild (>= 2015-2),
# dh-ada-library knowing that -dbg packages are obsolete.
 dh-ada-library (>= 6.7),
# To deduplicate examples in rules.
 rdfind, symlinks
Standards-Version: 4.0.1
Homepage: http://libre.adacore.com/libre/
Vcs-Mtn: www.ada-france.org org.debian.libaunit
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libaunit

Package: libaunit17.2017-dev
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Description: AUnit, a unit testing framework for Ada: development
 AUnit is a set of Ada packages based on the xUnit family of unit test
 frameworks. It's intended as a developer's tool to facilitate
 confident writing and evolution of Ada software. It is purposely
 lightweight, as one of its main goals is to make it easy to develop
 and run unit tests, rather than to generate artifacts for process
 management. The framework supports easy composition of sets of unit
 tests to provide flexibility in determining what tests to run for a
 given purpose.
 .
 Install this package if you want to write programs that use AUnit.
 Debian cannot redistribute the documentation for license reasons.
 It is available at
 http://docs.adacore.com/aunit-docs/html/aunit_cb/aunit_cb.html.

Package: libaunit17.2017
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: AUnit, a unit testing framework for Ada: shared library
 AUnit is a set of Ada packages based on the xUnit family of unit test
 frameworks. It's intended as a developer's tool to facilitate
 confident writing and evolution of Ada software. It is purposely
 lightweight, as one of its main goals is to make it easy to develop
 and run unit tests, rather than to generate artifacts for process
 management. The framework supports easy composition of sets of unit
 tests to provide flexibility in determining what tests to run for a
 given purpose.
 .
 This package contains the runtime shared library.

=== debian/rules ===
#!/usr/bin/make -f
#
# Debian Makefile for AUnit
# Copyright (c) 2009      Stephen Leake <stephen_leake@stephe-leake.org>
# Copyright (c) 2004-2006 Ludovic Brenta <ludovic@ludovic-brenta.org>
# Copyright (c) 2013-2017 Nicolas Boulenguez <nicolas@debian.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

# To debug, replace eval with error.
define new_line :=


endef
$(eval $(addsuffix $(new_line),$(shell sed -n '\
  s/^ gnat, gnat-\([0-9.]\+\),$$/ \
    GNAT_VERSION:=\1 \
  /p;\
  s/^Package: lib[a-z-]\+\([0-9.]\+\)$$/ \
    SOVERSION:=\1 \
  /p;\
  s/^Package: \(lib[a-z-]\+[0-9.]\+-dev\)$$/ \
    DEV_PKG:=\1 \
  /p;\
  ' debian/control)))

DEB_BUILD_MAINT_OPTIONS := hardening=+all
include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk
ADAFLAGS += -gnatfno -gnatwa -gnatVa

LIB_NAME := $(patsubst lib%,%,$(DEB_SOURCE))

%:
	dh $@ --with ada-library

######################################################################
# Ignore upstream Makefile/configure.
.PHONY: $(addprefix override_dh_auto_,configure build test install)
# clean target is OK.

override_dh_auto_build:
	$(MAKE) \
	  GPRBUILD='gprbuild $(BUILDER_OPTIONS) -XLIBRARY_KIND=static "-XADAFLAGS=$(ADAFLAGS) -fPIE" "-XSOVERSION=$(SOVERSION)"'

	$(MAKE) \
	  GPRBUILD='gprbuild $(BUILDER_OPTIONS) -XLIBRARY_KIND=dynamic $(foreach var,ADAFLAGS LDFLAGS SOVERSION,"-X$(var)=$($(var))")'

######################################################################
# The order in this list matters for rdfind.
INSTALLED_EXAMPLES := \
  $(subst examples/,debian/$(DEV_PKG)/usr/share/doc/$(DEV_PKG)/examples/, \
    $(wildcard examples/*))

.PHONY: override_dh_installexamples
override_dh_installexamples:
	dh_installexamples --all
  # Replace duplicate files with symlinks.
	rdfind -outputname /dev/null -makesymlinks true $(INSTALLED_EXAMPLES)
  # symlinks to make them relative (only if -indep build).
	symlinks -r -s -c $(INSTALLED_EXAMPLES)

######################################################################
.PHONY: override_dh_compress
override_dh_compress:
	dh_compress --package=$(DEV_PKG) --exclude=usr/share/doc/$(DEV_PKG)/examples/
# Check calculator/tests/stack-test.adb.gz
	dh_compress --remaining-packages

=== debian/watch ===
version=4

opts=\
  repack,\
  compression=xz,\
  filenamemangle=s/^.*download=//,\
  dversionmangle=s/^.*\.// \
https://qa.debian.org/cgi-bin/fakeupstream.cgi?upstream=adacore/aunit \
.*aunit-gpl@ANY_VERSION@-src@ARCHIVE_EXT@

# Major and minor versions must be set manually (see README.source),
# but at least trigger an alarm for new releases.

## libaunit 18

=== Makefile ===
--- 
+++ 
@@ -37,15 +37,20 @@
 clean: clean-lib
 	-${MAKE} -C docs clean
 
-install-clean:
+install-clean-legacy:
 ifneq (,$(wildcard $(INSTALL)/lib/gnat/manifests/aunit))
 	-$(GPRINSTALL) $(GPROPTS) --uninstall --prefix=$(INSTALL) \
 		--project-subdir=lib/gnat aunit
 endif
 
+install-clean: install-clean-legacy
+ifneq (,$(wildcard $(INSTALL)/share/gpr/manifests/aunit))
+	-$(GPRINSTALL) $(GPROPTS) --uninstall --prefix=$(INSTALL) aunit
+endif
+
 install: install-clean
 	$(GPRINSTALL) $(GPROPTS) -p -f --prefix=$(INSTALL) \
-		--no-build-var --project-subdir=lib/gnat lib/gnat/aunit.gpr
+		--no-build-var lib/gnat/aunit.gpr
 
 .PHONY: doc
 doc:

=== test/Makefile ===
--- 
+++ 
@@ -7,6 +7,7 @@
 
 RTS =
 TARGET =
+PROJECT_PATH_ARG =
 
 ifeq ($(RTS),)
    RTS = full
@@ -39,10 +40,6 @@
    RUN=./support/run-ppc-elf
 endif
 
-ifneq ($(findstring aunit.gpr,$(wildcard ../lib/gnat/*.gpr)),)
-   PROJECT_PATH_ARG = GPR_PROJECT_PATH=../lib/gnat
-endif
-
 build:
 	$(PROJECT_PATH_ARG) $(GPRBUILD) -p -Paunit_tests $(CONF_ARGS) $(LARGS)

=== debian/changelog ===
libaunit (18-2) unstable; urgency=medium

  * Rebuild in unstable for gnat-8 transition.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 27 Oct 2018 15:09:51 +0200

libaunit (18-1) experimental; urgency=medium

  * New upstream release. No package renaming in experimental.
  * Generalize patch for shared library and build flags.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 9 Jun 2018 14:54:38 +0200

libaunit (17.2017-3) experimental; urgency=medium

  * Rebuild with gnat-8.
    Rename shared library and -dev packages per Debian Ada policy.
  * Remove watch file. Explain why in README.source.
  * Debhelper 11.
  * Drop obsolete version restriction for dpkg-dev.
  * Standards-Version 4.1.4.
  * Update Homepage and Vcs-Mtn.
  * Stop repeating upstream URL in copyright file.
  * Let run time test produce more debug information.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 07 May 2018 13:34:50 +0200

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: libdevel
 Priority: optional
 Maintainer: Nicolas Boulenguez <nicolas@debian.org>
-Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 10),
- gnat, gnat-7,
+Build-Depends: debhelper (>= 11),
+ gnat, gnat-8,
 # This line is parsed by debian/rules.
 # gprbuild compatible with gnat-6
  gprbuild (>= 2015-2),
@@ -11,12 +11,12 @@
  dh-ada-library (>= 6.7),
 # To deduplicate examples in rules.
  rdfind, symlinks
-Standards-Version: 4.0.1
-Homepage: http://libre.adacore.com/libre/
-Vcs-Mtn: www.ada-france.org org.debian.libaunit
+Standards-Version: 4.1.4
+Homepage: https://www.adacore.com/community
+Vcs-Mtn: mtn://www.ada-france.org?org.debian.libaunit
 Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libaunit
 
-Package: libaunit17.2017-dev
+Package: libaunit18-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
 Description: AUnit, a unit testing framework for Ada: development
@@ -34,7 +34,7 @@
  It is available at
  http://docs.adacore.com/aunit-docs/html/aunit_cb/aunit_cb.html.
 
-Package: libaunit17.2017
+Package: libaunit18
 Section: libs
 Architecture: any
 Multi-Arch: same

=== debian/rules ===
#!/usr/bin/make -f

$(foreach line,$(shell sed -n '\
  s/^ gnat, gnat-\([0-9.]\+\),$$/ \
    GNAT_VERSION:=\1 \
  /p;\
  s/^Package: lib[a-z-]\+\([0-9.]\+\)$$/ \
    SOVERSION:=\1 \
  /p;\
  s/^Package: \(lib[a-z-]\+[0-9.]\+-dev\)$$/ \
    DEV_PKG:=\1 \
  /p;\
  ' debian/control),$(eval $(line)))

DEB_BUILD_MAINT_OPTIONS := hardening=+all
include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk
ADAFLAGS += -gnatfno -gnatwa -gnatVa

%:
	dh $@ --with ada-library

######################################################################
# Ignore upstream Makefile/configure.
.PHONY: $(addprefix override_dh_auto_,configure build test install)
# clean target is OK.

gpr_args = 'USER_GPR_ARGS=$(BUILDER_OPTIONS) $(foreach v,$(1),"-X$(v)=$($(v))")'
override_dh_auto_build:
	$(MAKE) \
	  $(call gpr_args, ADAFLAGS)

	$(MAKE) \
	  $(call gpr_args, ADAFLAGS LDFLAGS SOVERSION)

######################################################################
# The order in this list matters for rdfind.
INSTALLED_EXAMPLES := \
  $(subst examples/,debian/$(DEV_PKG)/usr/share/doc/$(DEV_PKG)/examples/, \
    $(wildcard examples/*))

.PHONY: override_dh_installexamples
override_dh_installexamples:
	dh_installexamples --all
  # Replace duplicate files with symlinks.
	rdfind -outputname /dev/null -makesymlinks true $(INSTALLED_EXAMPLES)
  # symlinks to make them relative (only if -indep build).
	symlinks -r -s -c $(INSTALLED_EXAMPLES)

######################################################################
.PHONY: override_dh_compress
override_dh_compress:
	dh_compress --package=$(DEV_PKG) --exclude=usr/share/doc/$(DEV_PKG)/examples/
# Check calculator/tests/stack-test.adb.gz
	dh_compress --remaining-packages

## libaunit 19

=== examples/test_caller/Makefile ===
all:
	gprbuild -p -Pharness/harness
clean:
	gprclean -Pharness/harness
	gprclean -Ptested_lib/testlib

=== debian/changelog ===
libaunit (19-3) unstable; urgency=medium

  * Reupload to unstable for gnat-9 transition.
  * Let rules only include the needed dpkg-dev snippet.
  * Drop redundant branch from Vcs-Git.
  * Standards-Versions: 4.5.0.
  * Wrap and sort dependencies. Use Debhelper 12 dh-sequence syntax.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 25 Feb 2020 11:22:20 +0100

libaunit (19-2) experimental; urgency=medium

  * Build-Depend: gnat-9. Closes: #939621. Then 19-dev Depends: gnat-9 as
    18-dev on gnat-8. Each compiler conflicts with previous versions of
    itself exactly in order to prevent coinstallations of -dev versions.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 07 Sep 2019 01:45:07 +0200

libaunit (19-1) experimental; urgency=medium

  * New upstream release, built in experimental with gnat-9.
    Rename library and -dev package accordingly.
  * Move VCS to salsa.debian.org.
  * Debhelper 12. Examples are not compressed anymore.
  * Standards-Version: 4.4.0.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 01 Sep 2019 21:41:19 +0200

=== debian/control ===
--- 
+++ 
@@ -2,21 +2,23 @@
 Section: libdevel
 Priority: optional
 Maintainer: Nicolas Boulenguez <nicolas@debian.org>
-Build-Depends: debhelper (>= 11),
- gnat, gnat-8,
+Build-Depends:
+ debhelper-compat (= 12),
+ dh-sequence-ada-library,
+ gnat, gnat-9,
 # This line is parsed by debian/rules.
 # gprbuild compatible with gnat-6
  gprbuild (>= 2015-2),
-# dh-ada-library knowing that -dbg packages are obsolete.
- dh-ada-library (>= 6.7),
 # To deduplicate examples in rules.
- rdfind, symlinks
-Standards-Version: 4.1.4
+ rdfind,
+ symlinks,
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: https://www.adacore.com/community
-Vcs-Mtn: mtn://www.ada-france.org?org.debian.libaunit
-Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libaunit
+Vcs-Browser: https://salsa.debian.org/debian/libaunit
+Vcs-Git: https://salsa.debian.org/debian/libaunit.git
 
-Package: libaunit18-dev
+Package: libaunit19-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
 Description: AUnit, a unit testing framework for Ada: development
@@ -34,7 +36,7 @@
  It is available at
  http://docs.adacore.com/aunit-docs/html/aunit_cb/aunit_cb.html.
 
-Package: libaunit18
+Package: libaunit19
 Section: libs
 Architecture: any
 Multi-Arch: same

=== debian/rules ===
--- 
+++ 
@@ -13,12 +13,14 @@
   ' debian/control),$(eval $(line)))
 
 DEB_BUILD_MAINT_OPTIONS := hardening=+all
-include /usr/share/dpkg/default.mk
+DEB_ADAFLAGS_MAINT_APPEND := -gnatfno -gnatwa -gnatVa
+DEB_LDFLAGS_MAINT_APPEND := -Wl,--no-undefined \
+  -Wl,--no-copy-dt-needed-entries -Wl,--no-allow-shlib-undefined
+include /usr/share/dpkg/buildflags.mk
 include /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk
-ADAFLAGS += -gnatfno -gnatwa -gnatVa
 
 %:
-	dh $@ --with ada-library
+	dh $@
 
 ######################################################################
 # Ignore upstream Makefile/configure.
@@ -46,10 +48,3 @@
 	rdfind -outputname /dev/null -makesymlinks true $(INSTALLED_EXAMPLES)
   # symlinks to make them relative (only if -indep build).
 	symlinks -r -s -c $(INSTALLED_EXAMPLES)
-
-######################################################################
-.PHONY: override_dh_compress
-override_dh_compress:
-	dh_compress --package=$(DEV_PKG) --exclude=usr/share/doc/$(DEV_PKG)/examples/
-# Check calculator/tests/stack-test.adb.gz
-	dh_compress --remaining-packages
